io.output( io.stderr )
module( ..., package.seeall )

local ut = require( 'udunits2' )
local uts = require( 'udunits2.system' )

setup = _G.setup

read_xml = _G.read_xml

function test_read_xml( )

   local system = read_xml()

   assert_true( ut.isa( system, 'system' ), 'is a system?' )

   assert_not_equal( nil, system:get_dimensionless_unit_one() )

   assert_not_equal( nil, system:get_unit_by_name( 'radian' ) )

   assert_not_equal( nil, system:get_unit_by_name( 'degrees' ) )

   assert_not_equal( nil, system:get_unit_by_symbol( "'" ) )

end

function test_new_system( )

   local system = uts.new()

   local handler = ut.set_error_message_handler( 'ignore' )

   -- this system should be empty except for the dimensionless unit
   assert_not_equal( nil, system:get_dimensionless_unit_one() )

   assert_equal( nil, system:get_unit_by_name( 'radian' ) )


end

function test_new_base_unit()

   local system = read_xml()

   local unit = assert( system:new_base_unit() )

   assert_true( ut.isa( unit, 'unit' ), 'is a unit?' )

end

function test_new_dimensionless_unit()

   local system = read_xml()

   local unit = assert( system:new_dimensionless_unit() )

end

function test_unmap_name_to_unit()

   local system = read_xml()

   assert_not_equal( nil, system:get_unit_by_name( "degree" ) )

   assert_true( system:unmap_name_to_unit( "degree", ut.ASCII ) )

   assert_equal( nil, system:get_unit_by_name( "degree" ) )

end


function test_unmap_symbol_to_unit()

   local system = read_xml()

   assert_not_equal( nil, system:get_unit_by_symbol( "'" ) )

   assert_true( system:unmap_symbol_to_unit( "'", ut.ASCII ) )

   assert_equal( nil, system:get_unit_by_symbol( "'" ) )

end

function test_parse()

   local system = read_xml()

   local unit = assert( system:parse( "20 degrees_C" ) )

end

